<?php 
	
// data-diagram WP plugin Web Service
	
	declare(strict_types=1);

	namespace DATADIAGRAMSPRO;
  
 
	require_once __DIR__ . '/../../../wp-load.php';

 	if ( ! defined( 'ABSPATH' ) ) exit('access denied'); // Exit if accessed out of context 
	
	require_once ABSPATH . 'wp-admin/includes/class-wp-filesystem-base.php';   
	
	
	require_once __DIR__ . '/SCHEMA-VALIDATOR.php';
	
	
	function my_error_handler($severity, $message, $file, $line) 
	{		
    	throw new \ErrorException($message, 0, $severity, $file, $line);
	}
	set_error_handler("DATADIAGRAMSPRO\my_error_handler");
	
	
	new REST($_POST['data']); 
		

	class REST // the class is basically a validator
	{
		private array $post = [];
		
		public function __construct(array $posts)
		{
			try
			{							
				$this->post = $posts;

				$user = get_current_user_id();

				if($user > 0)	
				{
					$xss = $this -> nonce();

					if($xss)
					{

						$x = $this->getting($posts, true);

						$this->reply($x);						
			
					}
					else
					{				
						errorReply();			
	
						return false;
					}
			
				}
				else
				{		
					errorReply();			

					return false;
				}
			
				return true;
			}
			catch(\Throwable $e)
			{	
				echo '{"status":"' . $e -> getMessage() . '"}';		
												
				return false;
			}	
				
		}
	
		private function getting(array $posts, bool $validate = false) : bool | int
		{
			try
			{					
				$base = ABSPATH . 'wp-content/uploads/data-diagrams/'; 
							
				if(!file_exists($base)) 
				{
					wp_mkdir_p($base);    					
				}
			
			
				$x = 0;
					
				foreach($posts as $key => $value)
				{			
					if(!file_exists($base . $key)) 
					{
						wp_mkdir_p($base . $key);		
					}
						
					foreach($value as $key2 => $value2)
					{	
						// clean
						$xmlStr  = str_replace("\\","", $value2);	

						if($xmlStr !== '')
						{
							// parse							
							$XMLDoc = $this -> parseXML($xmlStr);				
								
							if( $XMLDoc && ($key2 == 'svg' || $key2 == 'xsl') ) //
							{
								$xs = new SchemaValidator();
						
								$isValid = true;
					
								if($validate ==  true)
								{
									switch($key2)
									{
										case 'svg':

											$iXMLSchemaURL = __DIR__ . '/SVG1.1X.xsd'; // svg schema

											$isValid = $xs -> validate($XMLDoc, $iXMLSchemaURL);
			
											break;
							
										case 'xsl':
						
											$iXMLSchemaURL = __DIR__ . '/xslt.xsd'; // xsl schema
						
											$isValid = $xs -> validate($XMLDoc, $iXMLSchemaURL);
														
											break;
									}
								}
					
								if($isValid === true)
								{									
									$data = $XMLDoc->saveXML();

									$path = $base . $key . '/diagram.' . $key2;
								
									file_put_contents($path, $data); 
																
									$x++;		
								}

							} // if end
							else
							{
								throw new \Exception('invalid data');						
							}
						}

					} // inner foreach end
						
				} // top foreach end
				
				return $x;			
			
			}
			catch(\Throwable |  \DOMException $e)
			{	
				throw $e;	
							
				return false;
			}	
		}
		
		private function reply(int $count) : bool
		{
			try
			{														
				echo '{"status":' . $count . '}';
	
				return true;		
			}
			catch(\Throwable |  \DOMException $e)
			{	
				throw $e;	
							
				return false;
			}	
		}
		
		private function errorReply() : bool
		{
			try
			{														
				echo '{"status":"error"}';
	
				return true;		
			}
			catch(\Throwable |  \DOMException $e)
			{	
				throw $e;	
							
				return false;
			}	
		}
				
		private function nonce() : int | bool
		{
			try
			{			
				$n = \getallheaders()['X-Wp-Nonce'];
		
				$xss = \wp_verify_nonce($n, 'wp_rest');
																
				return $xss;		
			}
			catch(\Throwable |  \DOMException $e)
			{				
				throw $e;	
											
				return false;
			}	
		} 	
		
		private function parseXML(string $iXMLStr) : \DOMDocument | bool
		{// parse string
						
			try
			{							
				if($iXMLStr && $iXMLStr != '')
				{							
					// parse
					$xml = new \DOMDocument;

					$xml -> substituteEntities = false;

					$xml->loadXML($iXMLStr);
				
					// return this
					return $xml;				
				}
				else
				{
					throw new \Exception('no text to XML parse');
					
					return false;
				}
												
			}
			catch(\Throwable | \DOMException $e)
			{				
				throw new \Exception('invalid XML');
				
				return false;
			}	
		}	
	}

?>