<?php 
	
// data-diagram WP plugin	
	
	declare(strict_types=1);
	
	namespace DATADIAGRAMSPRO;
	
	
 	if ( ! defined( 'ABSPATH' ) ) exit('access denied'); // Exit if accessed directly 
 
 	if (count(get_included_files()) < 2) { header("HTTP/1.1 301 Moved Permanently"); header("Location: /"); exit; } 
  	
 
	/*
	Plugin Name:  Data Diagrams Pro
	Plugin URI:   https://data-diagrams.com
	Description:  Data visualizing responsive diagrams and charts: barcharts, areacharts, functioncharts, donutcharts, piecharts, spiderwebs, radarwebs, and more
	Version:      1.0
	Author:       data-diagrams.com
	Author URI:   https://www.cartouche.dk
	License:      GPL2
	License URI:  https://www.gnu.org/licenses/gpl-2.0.html
	Text Domain:  data-diagrams"
	Domain Path:  /
	*/
	
	
// short code		

	// [diagram id="3"]
	function diagram_shortcode(array $atts ) : string
	{
		$a = shortcode_atts( array(
			'id' => 1,
		), $atts );

				
		$id = $a['id'];
								
		$path = ABSPATH . 'wp-content/uploads/data-diagrams/' . $id . '/diagram.svg';
			
		$wp_filesystem = new \WP_Filesystem_Direct(null);
		$svg = $wp_filesystem->get_contents($path);
									
		return $svg;
				
	}	
	\add_shortcode( 'diagram', 'DATADIAGRAMSPRO\diagram_shortcode' );
	


// Allow SVG

	function svg_mime_types( $mimes )
	{
	 	 $mimes['svg'] = 'image/svg+xml';
	 	 return $mimes;
	}
	\add_filter( 'upload_mimes', 'DATADIAGRAMSPRO\svg_mime_types' );


// tool page
	
	// create admin page 
	\add_action('admin_menu', 'DATADIAGRAMSPRO\diagram_menu');

	function diagram_menu() {
		
		\add_menu_page('Data Diagrams Pro Settings', 'Diagrams Pro', 'manage_options', 'diagram-pro-settings', 'DATADIAGRAMSPRO\toolpage');

	} 

	function toolpage()
	{    	
		// bootstrap 5.3.3	
		\wp_enqueue_script('bootstrap-bundle-script', \plugin_dir_url(__FILE__) . '/bootstrap.bundle.min.js', array(), '5.3.3', true);    	
    	\wp_script_add_data( 'bootstrap-bundle-script', array( 'integrity', 'crossorigin' ) , array( 'sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz', 'anonymous' ) );
        
    	\wp_enqueue_style('bootstrap-style', \plugin_dir_url(__FILE__) . '/bootstrap.min.css', array(), '5.3.3', 'all');
    	\wp_style_add_data( 'bootstrap-style', array( 'integrity', 'crossorigin' ) , array( 'sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH', 'anonymous' ) );


		// data-diagrams
		\wp_enqueue_script('datadiagramspro-script', \plugin_dir_url(__FILE__) . '/datadiagrams-script.js', array(), null, true);    	
    
    	\wp_enqueue_style('datadiagramspro-style', \plugin_dir_url(__FILE__) . '/datadiagrams-styles.css', array(), null, 'all');
    
    		
		\wp_localize_script('datadiagramspro-script', 'wpApiSettings', array(
			'root' => \esc_url_raw(rest_url()),
			'nonce' => \wp_create_nonce('wp_rest'),			
			'url' => \esc_url_raw(plugin_dir_url(__FILE__))			
		));
		
		?>
									
		<div class="container-fluid mt-3">
		
			<div class="col">
		
				<h1>Data Diagrams Settings</h1>
			
				<div class="tab-content" id="myTabContent">
  
					<div class="tab-pane fade show active p-0 container-fluid position-relative" id="data" role="tabpanel" aria-labelledby="data-tab" tabindex="0">

						<p class="position-absolute" id="loading">Loading editor...</p>
										
					
						<iframe id="myiframe" class="container vh-100 p-0" loading="eager" src="https://data-diagrams.com/charts/areachart.html?task=10"></iframe>
				
					</div>
	
				</div>
			
			</div>
		
		</div>
		
		<?php
	}

?>